(function (window) {
    if (window.ILJSBridge) {
        return;
    }
    ;
    var ILJSBridge = /** @class */ (function () {
        function ILJSBridge() {
            this.uniqueId = 1;
            this.callbackCache = {};
        }
        ILJSBridge.prototype.syncCallNative = function (service, action, actionArgs) {
            let prompt = true;
            let vids = document.getElementsByTagName('video');
            for (let vid of vids) {
                if (!vid.paused) {
                    prompt = false;
                    break;
                }
            }
            if (!prompt) {
                return;
            }

            var message = {
                name: 'ILJSBridgeMessage',
                service: service || 'default',
                action: action,
                actionArgs: actionArgs,
            };
            return window.prompt(JSON.stringify(message));
        };
        ILJSBridge.prototype.callNative = function (service, action, actionArgs, successCallback, failCallback) {
            var message = {
                service: service || 'default',
                action: action,
                actionArgs: actionArgs,
                callbackId: null
            };
            if (successCallback || failCallback) {
                var callbackId = 'il_' + message.service + '_' + action + '_' + (this.uniqueId++) + '_' + new Date().getTime();
                this.callbackCache[callbackId] = {success:successCallback, fail:failCallback};;
                message.callbackId = callbackId;
            }
            if (window.webkit && window.webkit.messageHandlers) {
                window.webkit.messageHandlers.ILJSBridgeMessage.postMessage(JSON.stringify(message));
            } else if (window.ILJSBridgeMessage) {
                window.ILJSBridgeMessage.postMessage(JSON.stringify(message));
            }
        };
        ILJSBridge.prototype._handleMessageFromNative = function (callbackMessage) {
            var status = callbackMessage.status;
            var callback = this.callbackCache[callbackMessage.callbackId];
            if (callback) {
                if (status == undefined || !status) {
                   callback.fail(callbackMessage.data);
                } else {
                   callback.success(callbackMessage.data);
                }
                this.callbackCache[callbackMessage.callbackId] = null;
                delete this.callbackCache[callbackMessage.callbackId];
            }
        };
        return ILJSBridge;
    }());
    var ILJSBridgeInstance = new ILJSBridge();
    var ILJSBridgeConfig = /** @class */ (function () {
        function ILJSBridgeConfig() {
        
        }
        ILJSBridgeConfig.prototype.init = function () {
            window.ILJSBridge = ILJSBridgeInstance;
        };
        return ILJSBridgeConfig;
    }());
    window.ILJSBridgeConfig = new ILJSBridgeConfig();
    window.ILJSBridgeConfig.init();
})(window);
